## mingw-w64-paraview-5.12.1-2.src.tar.zst

=== Adaptors/CTH/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause

set(classes
  vtkCTHSource
  vtkCTHDataArray
)

set(headers
  CTHAdaptor.h
)

set(sources
  CTHAdaptor.cxx
)

vtk_module_add_module(ParaView::AdaptorsCTH
  CLASSES ${classes}
  HEADERS ${headers}
  SOURCES ${sources}
)
vtk_module_client_server_exclude()

=== Adaptors/Python/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause

set(python_files
  cp_pythonadaptorscript.py
  pythonadaptordriver.py
)

vtk_module_add_python_package(ParaView::AdaptorsPython
  FILES               ${python_files}
  PACKAGE             "paraview.adaptors"
  MODULE_DESTINATION  "${PARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX}")

vtk_module_add_python_module(ParaView::AdaptorsPython
  PACKAGES "paraview.adaptors")

=== Incubator/CAVEInteractionStyles/CMakeLists.txt ===
set(classes
  vtkSMVRControlSliceOrientationStyleProxy
  vtkSMVRControlSlicePositionStyleProxy
  vtkSMVRGrabPointStyleProxy
  vtkSMVRGrabTransformStyleProxy
  vtkSMVRGrabWorldStyleProxy
  vtkSMVRInteractorStyleProxy
  vtkSMVRMovePointStyleProxy
  vtkSMVRPythonInteractorStyleProxy
  vtkSMVRResetTransformStyleProxy
  vtkSMVRSkeletonStyleProxy
  vtkSMVRSpaceNavigatorGrabWorldStyleProxy
  vtkSMVRStylusStyleProxy
  vtkSMVRTrackStyleProxy
  vtkSMVRVirtualHandStyleProxy
  vtkVRQueue)

vtk_module_add_module(ParaViewIncubator::CAVEInteractionStyles
  CLASSES ${classes})

=== Plugins/AnalyzeNIfTIReaderWriter/CMakeLists.txt ===
paraview_add_plugin(AnalyzeNIfTIReaderWriter
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  MODULES AnalyzeNIfTIIO::NIfTIIO
  MODULE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/NIfTIIO/vtk.module")

if (BUILD_TESTING)
  add_subdirectory(Testing)
endif ()

=== Plugins/BivariateRepresentations/CMakeLists.txt ===
set(interfaces)
set(sources)

if (PARAVIEW_USE_QT)
  list(APPEND sources
    pqBivariateManager.cxx
    pqBivariateManager.h
    vtkPVBivariatePluginLocation.cxx
    vtkPVBivariatePluginLocation.h)

  paraview_plugin_add_auto_start(
    CLASS_NAME "pqBivariateManager"
    STARTUP onStartup
    SHUTDOWN onShutdown
    INTERFACES autostart_interface
    SOURCES autostart_sources)
  list(APPEND interfaces
    ${autostart_interface})
  list(APPEND sources
    ${autostart_sources})

  paraview_plugin_add_location(
    CLASS_NAME vtkPVBivariatePluginLocation
    INTERFACES location_interfaces
    SOURCES location_sources)

  list(APPEND interfaces
    ${location_interfaces})
  list(APPEND sources
    ${location_sources})

  set(resources
    Bremm.png
    Schumann.png
    Steiger.png
    Teulingfig2.png)

  foreach(inputfile IN LISTS resources)
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/Resources/${inputfile}
      "${CMAKE_BINARY_DIR}/${_paraview_build_plugin_directory}/Resources/${inputfile}"
      COPYONLY)
  endforeach()

  install(
    DIRECTORY Resources
    DESTINATION "${_paraview_build_plugin_directory}"
    COMPONENT   "${_paraview_build_PLUGINS_COMPONENT}")
endif ()

paraview_add_plugin(BivariateRepresentations
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  UI_INTERFACES ${interfaces}
  SOURCES ${sources}
  MODULES BivariateRepresentations::vtkBivariateRepresentations
  MODULE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/Representations/vtk.module"
  XML_DOCUMENTATION OFF)

if (BUILD_TESTING)
  add_subdirectory(Testing)
endif()

=== Plugins/DSP/CMakeLists.txt ===
set(sources)
set(interfaces)
set(uifiles)

option(PARAVIEW_PLUGIN_dsp_enable_audio_player "Enable building the Audio Player Dock. Requires Qt Multimedia." OFF)
mark_as_advanced(PARAVIEW_PLUGIN_dsp_enable_audio_player)

if (PARAVIEW_USE_QT AND PARAVIEW_PLUGIN_dsp_enable_audio_player)
  find_package("Qt${PARAVIEW_QT_MAJOR_VERSION}" REQUIRED Widgets OPTIONAL_COMPONENTS Multimedia)

  if (NOT TARGET "Qt${PARAVIEW_QT_MAJOR_VERSION}::Multimedia")
    message(FATAL_ERROR
      "Component 'Qt5::Multimedia' required for the DSP plugin not found. Use "
      "PARAVIEW_PLUGIN_dsp_enable_audio_player to disable the audio player if necessary, or install 'Qt5::Multimedia'")
  endif ()

  list(APPEND sources
    pqAudioPlayer.cxx
    pqAudioPlayer.h)

  paraview_plugin_add_dock_window(
    CLASS_NAME pqAudioPlayer
    DOCK_AREA Right
    INTERFACES dock_interfaces
    SOURCES dock_sources)

  list(APPEND interfaces
    ${dock_interfaces})
  list(APPEND sources
    ${dock_sources})
  list(APPEND uifiles pqAudioPlayer.ui)
endif ()

paraview_add_plugin(DigitalSignalProcessing
  VERSION "1.0"
  UI_FILES ${uifiles}
  UI_INTERFACES ${interfaces}
  SOURCES ${sources}
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  MODULES
    DigitalSignalProcessing::DSPDataModel
    DigitalSignalProcessing::DSPFiltersPlugin
  MODULE_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/DataModel/vtk.module"
    "${CMAKE_CURRENT_SOURCE_DIR}/Filters/vtk.module")

if (PARAVIEW_USE_QT AND PARAVIEW_PLUGIN_dsp_enable_audio_player)
  target_link_libraries(DigitalSignalProcessing
    PRIVATE
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::Widgets"
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::Multimedia")

  target_compile_definitions(DigitalSignalProcessing PRIVATE QT_NO_KEYWORDS)
endif()

if (BUILD_TESTING AND BUILD_SHARED_LIBS)
  add_subdirectory(Testing)
endif()

=== Remoting/Application/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkInitializationHelper)

set(private_headers
  vtkPVInitializer.h)

vtk_module_add_module(ParaView::RemotingApplication
  CLASSES ${classes}
  PRIVATE_HEADERS ${private_headers})
vtk_module_link(ParaView::RemotingApplication
  PRIVATE
    paraview_client_server
    paraview_server_manager)
vtk_module_client_server_exclude()

set(xml_files
  Resources/extractors.xml
  Resources/internal_writers.xml
  Resources/utilities.xml)

function (_paraview_remoting_application_optional_xml)
  cmake_parse_arguments(PARSE_ARGV 0 _paraview_optional_xml
    ""
    ""
    "TARGETS;FILES")

  foreach (_paraview_optional_xml_target IN LISTS _paraview_optional_xml_TARGETS)
    _vtk_module_optional_dependency_exists("${_paraview_optional_xml_target}"
      SATISFIED_VAR _have_dep_module)
    if (NOT _have_dep_module)
      return ()
    endif ()
  endforeach ()

  set(xml_files "${xml_files}" ${_paraview_optional_xml_FILES} PARENT_SCOPE)
endfunction ()

_paraview_remoting_application_optional_xml(
  TARGETS VTK::CommonComputationalGeometry
  FILES   Resources/proxies_computationalgeometry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::DomainsChemistry
  FILES   Resources/filters_domainschemistry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOChemistry
  FILES   Resources/readers_iochemistry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersAMR
  FILES   Resources/filters_filtersamr.xml
          Resources/sources_filtersamr.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersCellGrid
  FILES   Resources/filters_filterscellgrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersCore
  FILES   Resources/filters_filterscore.xml
          Resources/sources_filterscore.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersPoints
  FILES   Resources/filters_filterspoints.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersExtraction
  FILES   Resources/filters_filtersextraction.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersFlowPaths
  FILES   Resources/filters_filtersflowpaths.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneral
  FILES   Resources/filters_filtersgeneral.xml
          Resources/sources_filtersgeneral.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneral
          VTK::FiltersGeometry
          ParaView::VTKExtensionsFiltersGeneral
  FILES   Resources/filters_plotonintersectioncurves.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneral
          VTK::FiltersParallel
          ParaView::VTKExtensionsFiltersGeneral
  FILES   Resources/filters_normalglyphs.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeneric
  FILES   Resources/filters_filtersgeneric.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersGeometry
  FILES   Resources/filters_filtersgeometry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallel
  FILES   Resources/filters_filtersparallel.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallelMPI
  FILES   Resources/filters_filtersparallelmpi.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersHybrid
  FILES   Resources/filters_filtershybrid.xml
          Resources/readers_filtershybrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersHyperTree
  FILES   Resources/filters_filtershypertree.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersModeling
  FILES   Resources/filters_filtersmodeling.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersSources
  FILES   Resources/sources_filterssources.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersStatistics
  FILES   Resources/filters_filtersstatistics.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingCore
  FILES   Resources/filters_imagingcore.xml
          Resources/sources_imagingcore.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingFourier
  FILES   Resources/filters_imagingfourier.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingGeneral
  FILES   Resources/filters_imaginggeneral.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingHybrid
  FILES   Resources/filters_imaginghybrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingSources
  FILES   Resources/sources_imagingsources.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ImagingStatistics
  FILES   Resources/filters_imagingstatistics.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallelDIY2
  FILES   Resources/filters_filtersparalleldiy2.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallelVerdict
  FILES   Resources/filters_filtersparallelverdict.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersTensor
  FILES   Resources/filters_filterstensors.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersTexture
  FILES   Resources/filters_filterstexture.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersVerdict
  FILES   Resources/filters_filtersverdict.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCellGrid
  FILES   Resources/readers_iocellgrid.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOXML
          VTK::IOParallelXML
  FILES   Resources/readers_ioxml.xml
          Resources/writers_ioxml.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOAlembic
  FILES   Resources/proxies_alembic.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IONetCDF
  FILES   Resources/readers_ionetcdf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOParallelNetCDF
  FILES   Resources/readers_ioparallelnetcdf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOXdmf2
  FILES   Resources/proxies_xdmf2.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOXdmf3
  FILES   Resources/proxies_xdmf3.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOGDAL
  FILES   Resources/proxies_gdal.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOLAS
  FILES   Resources/proxies_las.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOPDAL
  FILES   Resources/proxies_pdal.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCityGML
  FILES   Resources/proxies_citygml.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOHDF
  FILES   Resources/readers_iohdf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOSegY
  FILES   Resources/proxies_segy.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOADIOS2
  FILES   Resources/proxies_adios2_core.xml
          Resources/proxies_adios2_vtx.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOFides
  FILES   Resources/proxies_fides.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOOMF
  FILES   Resources/proxies_omf.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOMotionFX
  FILES   Resources/proxies_motionfx.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOLegacy
  FILES   Resources/writers_iolegacy.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOGeometry
  FILES   Resources/readers_iogeometry.xml
          Resources/writers_iogeometry.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOOCCT
  FILES   Resources/readers_ioocct.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOPLY
  FILES   Resources/readers_ioply.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOParallel
  FILES   Resources/readers_ioparallel.xml
          Resources/writers_ensight.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOParallelLSDyna
  FILES   Resources/readers_lsdyna.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOInfovis
  FILES   Resources/readers_ioinfovis.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOTecplotTable
  FILES   Resources/readers_iotecplottable.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOVPIC
  FILES   Resources/readers_iovpic.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOTRUCHAS
  FILES   Resources/readers_iotruchas.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOVeraOut
  FILES   Resources/readers_ioveraout.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOH5part
  FILES   Resources/readers_ioh5part.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOH5Rage
  FILES   Resources/readers_ioh5rage.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOPIO
  FILES   Resources/readers_iopio.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCONVERGECFD
  FILES   Resources/readers_ioconvergecfd.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCGNSReader
  FILES   Resources/readers_iocgns.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOFLUENTCFF
  FILES   Resources/readers_iofluentcff.xml)

_paraview_remoting_application_optional_xml(
  TARGETS ParaView::VTKExtensionsIOCGNSWriter
  FILES   Resources/writers_iocgns.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersOpenTURNS
  FILES   Resources/proxies_openturns.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::MomentInvariants
  FILES   Resources/MomentInvariants.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::ParallelMomentInvariants
  FILES   Resources/ParallelMomentInvariants.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::RenderingFreeType
  FILES   Resources/sources_renderingfreetype.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::InteractionWidgets
  FILES   Resources/proxies_interactionwidgets.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::FiltersParallel
          VTK::ImagingFourier
          ParaView::VTKExtensionsExtraction
  FILES   Resources/filters_selectionfftovertime.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOIOSS
  FILES   Resources/readers_ioioss.xml
          Resources/writers_ioioss.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOOpenVDB
  FILES   Resources/readers_ioopenvdb.xml
          Resources/writers_ioopenvdb.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOCatalystConduit
  FILES   Resources/proxies_conduit.xml)

_paraview_remoting_application_optional_xml(
  TARGETS VTK::IOFDS
  FILES   Resources/readers_iofds.xml)

_vtk_module_optional_dependency_exists(VTK::PythonInterpreter
  SATISFIED_VAR _have_vtk_pythoninterpreter)
if (TARGET _have_vtk_pythoninterpreter)
  _vtk_module_set_module_property(ParaView::RemotingApplication APPEND
    PROPERTY  "forward_link"
    VALUE     VTK::PythonUsed)
endif ()

if (PARAVIEW_USE_PYTHON)
  list(APPEND xml_files
    Resources/readers_openpmd.xml
    Resources/readers_savg.xml)
  list(APPEND xml_files
    Resources/extractors_python.xml)
endif()

paraview_add_server_manager_xmls(
  XMLS  ${xml_files})

=== VTKExtensions/Extraction/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkExtractSelectionRange
  vtkPConvertSelection
  vtkExtractCellsAlongLine
  vtkPVExtractCellsByType
  vtkPVExtractSelection
  vtkPVSelectionSource
  vtkPVSingleOutputExtractSelection
  vtkSelectArraysExtractBlocks)

vtk_module_add_module(ParaView::VTKExtensionsExtraction
  CLASSES ${classes})

paraview_add_server_manager_xmls(
  XMLS  Resources/extraction_filters.xml)

=== VTKExtensions/FiltersParallelDIY2/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkPVGhostCellsGenerator
  vtkPVProbeLineFilter)

vtk_module_add_module(ParaView::VTKExtensionsFiltersParallelDIY2
  CLASSES ${classes})

paraview_add_server_manager_xmls(
  XMLS  Resources/parallel_diy_filters.xml)

=== Clients/Web/Testing/CMakeLists.txt ===
add_subdirectory(Cxx)
add_subdirectory(Python)

=== Plugins/DigitalRockPhysics/Filters/CMakeLists.txt ===
set(classes
  vtkPMaterialClusterAnalysisFilter
  vtkPMaterialClusterExplodeFilter)

vtk_module_add_module(DigitalRockPhysics::DigitalRocksFilters
  CLASSES ${classes})

paraview_add_server_manager_xmls(
    XMLS  DigitalRockPhysics.xml)

=== Plugins/NonOrthogonalSource/Testing/CMakeLists.txt ===
if (BUILD_SHARED_LIBS)
  set (xmls
    NonOrthogonalSliceView.xml
    NonOrthographicOrthographicView.xml
  )

  set (NonOrthogonalSliceView_FORCE_SERIAL TRUE)

  paraview_add_client_tests(
    LOAD_PLUGIN "NonOrthogonalSource"
    BASELINE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline"
    TEST_DATA_TARGET ParaViewData
    TEST_SCRIPTS ${xmls}
  )
  paraview_add_client_server_tests(
    LOAD_PLUGIN "NonOrthogonalSource"
    BASELINE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline"
    TEST_DATA_TARGET ParaViewData
    TEST_SCRIPTS ${xmls}
  )
  paraview_add_client_server_render_tests(
    LOAD_PLUGIN "NonOrthogonalSource"
    BASELINE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline"
    TEST_DATA_TARGET ParaViewData
    TEST_SCRIPTS ${xmls}
  )
endif ()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=paraview
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.12.1
pkgrel=2
pkgdesc="Parallel Data Analysis and Visualization Application based on VTK. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.paraview.org/'
msys2_repository_url="https://gitlab.kitware.com/paraview/paraview"
msys2_references=(
  'archlinux: paraview'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-cgns"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-gl2ps"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libogg"
         "${MINGW_PACKAGE_PREFIX}-liblas"
         "${MINGW_PACKAGE_PREFIX}-libtheora"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-openturns"
         "${MINGW_PACKAGE_PREFIX}-pdal"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt5-svg"
         "${MINGW_PACKAGE_PREFIX}-qt5-tools"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt5-xmlpatterns"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-libharu"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-python-numpy"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib")
source=("https://www.paraview.org/files/v${pkgver%.*}/ParaView-v${pkgver}.tar.xz"
        "001-dll-export-some-vtk-functions.patch"
        "002-no-exact-version-for-fast_float.patch"
        "004-always-link-with-pdalcpp.patch::https://gitlab.kitware.com/vtk/vtk/-/commit/ccee5db7.patch")
sha256sums=('927f880c13deb6dde4172f4727d2b66f5576e15237b35778344f5dd1ddec863e'
            'a9b9292be90c259f0aa058e3f4a7a08b6218f20e6cb2a71e214acda2d2302a50'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '5b734e933a91e316ec9b95f5f526e35d096cb3db2ba4868f8a7c432ec0c3d530')

prepare() {
  cd "${srcdir}"/ParaView-v${pkgver}

  cd VTK
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    # Copied from mingw-w64-vtk/007-dll-export-some-functions.patch
    patch -Np1 -i "${srcdir}"/001-dll-export-some-vtk-functions.patch
  fi

  patch -p1 -i "${srcdir}"/002-no-exact-version-for-fast_float.patch
  patch -p1 -i "${srcdir}"/004-always-link-with-pdalcpp.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys; print(f'{sys.version_info.major}.{sys.version_info.minor}')")

  CXXFLAGS+=" -w -Wno-register" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DVTK_IGNORE_CMAKE_CXX11_CHECKS=ON \
      -DPARAVIEW_BUILD_SHARED_LIBS=ON \
      -DPARAVIEW_USE_PYTHON=ON \
      -DPARAVIEW_USE_QT=ON \
      -DPARAVIEW_USE_MPI=OFF \
      -DPARAVIEW_ENABLE_GDAL=ON \
      -DPARAVIEW_ENABLE_LAS=ON \
      -DPARAVIEW_ENABLE_OPENTURNS=ON \
      -DPARAVIEW_ENABLE_PDAL=ON \
      -DPARAVIEW_VERSIONED_INSTALL=OFF \
      -DPARAVIEW_CUSTOM_LIBRARY_SUFFIX="pv${pkgver%.*}" \
      -DPARAVIEW_BUILD_WITH_EXTERNAL=ON \
      -DPARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX="lib/python${_pyver}/site-packages/pv/" \
      -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
      -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_token=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      ../ParaView-v${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  install -Dm644 "${srcdir}/ParaView-v${pkgver}/Copyright.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
